// flocking_render.fs
// OpenGL SuperBible
// Example of using transform feedback to implement flocking
// Program by Graham Sellers.

// Flocking render fragment shader
#version 330

uniform sampler2D texture1;
uniform sampler2D texture2;
uniform sampler2D texture3;

in vec3 tex_id;
in vec2 texCoord;

layout (location = 0) out vec4 color;

void main(void)
{
	if (tex_id.r > 0.0f)
	{
		color = texture2D(texture1, texCoord.st);
	} else
	{
		if (tex_id.g > 0.0f)
		{
			color = texture2D(texture2, texCoord.st);
		} else
		{
			color = texture2D(texture3, texCoord.st);
		}

	}
	
	
}
