﻿
#version 330 core
#define NUM_VOLUME_SAMPLES 60
in vec2 texCoord;

uniform vec2 lightScreenspace;
uniform sampler2D background;
//uniform sampler2D quadTexture;

out vec4 fragColor;

const float exposure = 0.60;
const float decay    = 1.0;
const float density  = 0.95;
const float weight   = 0.025;

void main(void) {

	vec2 deltaTextCoord = vec2(texCoord.xy - lightScreenspace);

	//vec2 deltaTextCoord = vec2(texCoord.xy - vec2(0.5,0.9));
	
	vec2 tmptextCoord = texCoord;
    deltaTextCoord *= 1.0 / float(NUM_VOLUME_SAMPLES)*density;
    float illuminationDecay = 1.0;
	float gamma = 2.2f;	
	vec4 finalCol;
	//vec4 finalCol = texture2D(quadTexture, texCoord);

    vec4 sample = pow(texture2D(background, tmptextCoord ), vec4(1.0/gamma));
  
	for(int i=0; i < NUM_VOLUME_SAMPLES ; i++)
	{
		tmptextCoord -= deltaTextCoord;
		sample += texture2D(background, tmptextCoord );
		sample *= illuminationDecay * weight;
		finalCol += sample;
		illuminationDecay *= decay;
	}

	finalCol *= exposure;
	fragColor = pow(finalCol, vec4(gamma));
	//fragColor  += finalCol;
	//fragColor = texture2D(background, texCoord );
}