#version 330 core


smooth in vec3 varyinglightDir;
smooth in vec3 normal; 

uniform vec4 ambientColor;
uniform vec4 diffuseColor;
//uniform vec4 specColor;

out vec4 fragColor;

void main(void)
{

	float diff = max(0.0, dot(normalize(normal),normalize(varyinglightDir)));

	fragColor = diff* diffuseColor;

	fragColor += ambientColor;

	vec3 vertReflection = normalize(reflect(-normalize(varyinglightDir),normalize(normal)));

	float spec = max(0.0, dot(normalize(normal), vertReflection));

	if(diff !=0){
		float fspec = pow(spec,128.0);
		fragColor.rgb +=vec3(fspec,fspec,fspec);
	}

}
