#version 330 core

in vec4 vertexPosition;
in vec3 vertexNormal;

uniform vec3 lightPosition;
uniform mat4 mvMatrix;
uniform mat4 mvpMatrix;
uniform mat4 normalMatrix; 

smooth out vec3 normal;
smooth out vec3 varyinglightDir;


void main(void)
{

	normal =(normalMatrix*vec4(vertexNormal,1.0)).xyz;
	vec4 vertPosition4 =  mvMatrix*vertexPosition;
	vec3 vertPosition3 = vertPosition4.xyz/ vertPosition4.w;

	varyinglightDir = normalize(lightPosition - vertPosition3);

	gl_Position = mvpMatrix* vertexPosition;
	
}

